

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>shyft.energy_market.stm &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>shyft.energy_market.stm</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for shyft.energy_market.stm</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">...utilities</span> <span class="kn">import</span> <span class="n">environ_util</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Union</span>
<span class="kn">from</span> <span class="nn">..core</span> <span class="kn">import</span> <span class="n">ModelInfo</span><span class="p">,</span> <span class="n">run_state</span>
<span class="kn">from</span> <span class="nn">..core</span> <span class="kn">import</span> <span class="n">_core</span>  <span class="c1"># need to pull in dependent base-types</span>
<span class="kn">from</span> <span class="nn">._stm</span> <span class="kn">import</span> <span class="o">*</span>

<span class="c1"># backward compatible names after renaming</span>
<span class="n">Aggregate</span><span class="o">=</span><span class="n">Unit</span>
<span class="n">AggregateList</span><span class="o">=</span><span class="n">UnitList</span>
<span class="n">WaterRoute</span><span class="o">=</span><span class="n">Waterway</span>
<span class="n">PowerStation</span><span class="o">=</span><span class="n">PowerPlant</span>
<span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_aggregate</span><span class="o">=</span><span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_unit</span>
<span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_power_station</span><span class="o">=</span><span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_power_plant</span>
<span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_water_route</span><span class="o">=</span><span class="n">HydroPowerSystem</span><span class="o">.</span><span class="n">create_waterway</span>
<span class="c1"># end backward compat section</span>

<span class="c1"># Optional Shop integration</span>
<span class="c1"># Set Shop API specific environment variable ICC_COMMAND_PATH,</span>
<span class="c1"># value pointing to the shared library path where the solver libraries</span>
<span class="c1"># and license file should be located.</span>
<span class="c1"># Note: Needed by DStmServer.do_optimize, as well as subpackage shop.</span>
<span class="n">environ_util</span><span class="o">.</span><span class="n">set_environment</span><span class="p">(</span><span class="s1">&#39;ICC_COMMAND_PATH&#39;</span><span class="p">,</span> <span class="n">environ_util</span><span class="o">.</span><span class="n">lib_path</span><span class="p">)</span>


<div class="viewcode-block" id="ReadAccess"><a class="viewcode-back" href="../../../content/energy_market/api.html#shyft.energy_market.stm.ReadAccess">[docs]</a><span class="k">class</span> <span class="nc">ReadAccess</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Context manager for read-only operation with a SharedMutex</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">mtx</span><span class="p">:</span> <span class="n">SharedMutex</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mtx</span> <span class="o">=</span> <span class="n">mtx</span>

    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">read_lock</span> <span class="o">=</span> <span class="n">ReadLock</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mtx</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">read_lock</span>

    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">exc_type</span><span class="p">,</span> <span class="n">exc_val</span><span class="p">,</span> <span class="n">exc_tb</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">read_lock</span><span class="o">.</span><span class="n">unlock</span><span class="p">()</span></div>


<div class="viewcode-block" id="WriteAccess"><a class="viewcode-back" href="../../../content/energy_market/api.html#shyft.energy_market.stm.WriteAccess">[docs]</a><span class="k">class</span> <span class="nc">WriteAccess</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Context manager for exclusive right to a mutex.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">rl</span><span class="p">:</span> <span class="n">Union</span><span class="p">[</span><span class="n">UpgradableLock</span><span class="p">,</span> <span class="n">SharedMutex</span><span class="p">]):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">rl</span> <span class="o">=</span> <span class="n">rl</span>

    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rl</span><span class="p">,</span> <span class="n">UpgradableLock</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lock</span> <span class="o">=</span> <span class="n">UpgradeLock</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rl</span><span class="p">)</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rl</span><span class="p">,</span> <span class="n">SharedMutex</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lock</span> <span class="o">=</span> <span class="n">WriteLock</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rl</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Unable to create write lock for input to WriteAccess&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">lock</span>

    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">exc_type</span><span class="p">,</span> <span class="n">exc_val</span><span class="p">,</span> <span class="n">exc_tb</span><span class="p">):</span>
        <span class="k">del</span> <span class="bp">self</span><span class="o">.</span><span class="n">lock</span></div>


<div class="viewcode-block" id="UpgradableAccess"><a class="viewcode-back" href="../../../content/energy_market/api.html#shyft.energy_market.stm.UpgradableAccess">[docs]</a><span class="k">class</span> <span class="nc">UpgradableAccess</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Context manager for shared-access to a mutex. Can then later be upgraded to exclusive access rights.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">mtx</span><span class="p">:</span> <span class="n">SharedMutex</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mtx</span> <span class="o">=</span> <span class="n">mtx</span>

    <span class="k">def</span> <span class="fm">__enter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lock</span> <span class="o">=</span> <span class="n">UpgradableLock</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mtx</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">lock</span>

    <span class="k">def</span> <span class="fm">__exit__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">exc_type</span><span class="p">,</span> <span class="n">exc_val</span><span class="p">,</span> <span class="n">exc_tb</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lock</span><span class="o">.</span><span class="n">unlock</span><span class="p">()</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>